=== debian/changelog ===
coolreader3 (3.1.2.3-1mx19+1) mx; urgency=medium

  * Rebuild for MX 19.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 11 Jul 2019 11:43:20 -0700

coolreader3 (3.1.2.3-1mx17+1) mx; urgency=medium

  * Rebuild for MX 17.
  * Bump to debhelper 9 compat.
  * Use libjpeg-dev and libpng-dev build-depends.
  * Disable fix_freetype_headers_path.patch.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 04 Dec 2017 14:45:39 -0800

coolreader3 (3.1.2.3-1mx150+1) mx; urgency=medium

  * New release; rebuild for MX 15.

 -- Steven Pusser (Stevo) <maintainer@mepiscommunity.org>  Tue, 05 Jan 2016 19:35:35 -0800

coolreader3 (3.0.59.2-1mcr120+1) mepis; urgency=low

  * New upstream release:
  * Add fix-ini.patch so settings are saved.
  * Add Conflicts: for cr3
  * debian/rules: build static unrar support.

 -- Steven Pusser (Stevo) <maintainer@mepiscommunity.org>  Sat, 29 Mar 2014 14:22:46 -0700

coolreader3 (3.0.56-7mcr120+1) mepis; urgency=low

  * Rebuild for MEPIS 12.0.
  * debian/control: change package name to coolreader3.
  * debian/rules: compress deb packages with xz.
  * switch to debhelper-based rules file.
  * remove cdbs from build-depends.
  * revamp list of dependencies, just depend on dh_shlibs to get them.

 -- Steven Pusser (Stevo) <maintainer@mepiscommunity.org>  Wed, 26 Mar 2014 20:32:14 -0700

cr3 (3.0.56-7) unstable; urgency=low

  * merge upstream changes

 -- Vadim Lopatin <buggins@fromru.com>  Wed, 21 Mar 2012 09:25:00 +0400

cr3 (3.0.50-3) unstable; urgency=low

  * merge upstream changes

 -- Vadim Lopatin <buggins@fromru.com>  Tue, 23 Aug 2011 10:25:49 +0300

cr3 (3.0.49-13) unstable; urgency=low

  * merge upstream changes

 -- Vadim Lopatin <buggins@fromru.com>  Fri, 12 Aug 2011 10:25:49 +0300

cr3 (3.0.44-05) unstable; urgency=low

  * merge upstream changes

 -- Vadim Lopatin <buggins@fromru.com>  Mon, 14 Feb 2011 10:25:49 +0300

cr3 (3.0.43-12) unstable; urgency=low

  * create debian package

 -- Vadim Lopatin <buggins@fromru.com>  Mon, 07 Feb 2011 12:05:49 +0300
