=== debian/control ===
Source: coolreader3
Section: text
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
Bugs: mailto: <stevep@mxlinux.org>
XSBC-Original-Maintainer: Vadim Lopatin <buggins@fromru.com>
Build-Depends: debhelper (>= 9), cmake, zlib1g-dev, libpng-dev,
 libjpeg-dev, libfreetype6-dev, libfontconfig1-dev, libqt4-dev 
Standards-Version: 3.9.1
Homepage: http://sourceforge.net/projects/crengine/

Package: coolreader3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: cr3
Replaces: cr3
Description: e-book reader
 Cool Reader 3 is a multiplatform e-book viewer with support of TXT, FB2, HTML,
 RTF, CHM, EPUB, and TRC file formats.
 Fully supports FB2 format: tables, footnotes, CSS based formatting.
 Autodetects TXT file format and encoding, and reflows it for easy reading.
 Supports table of contents, search, bookmarks.
 Supports window and fullscreen modes, paperbook-like pages or scroll view.
 Book formatting is customizable using CSS files.
