=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_configure:
	dh_auto_configure -- \
		-DGUI=QT \
		-DCMAKE_BUILD_TYPE=Release \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DDOC_DATA_COMPRESSION_LEVEL=3 \
		-DDOC_BUFFER_SIZE=0x2500000 \
		-DMAX_IMAGE_SCALE_MUL=2 \
		-DUSE_UNRAR=1

%:
	dh  $@ --parallel
